/*-
 * Copyright (C)2000..2014 @BABOLO http://www.babolo.ru/\n\
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: deleted.h,v 1.2 2014/09/29 20:13:04 babolo Exp $
 */

#ifndef   NAMEPID
# define  NAMEPID "..."
#endif /* NAMEPID */

#define MY_ID        0x1984e34f8969adfb
#define BONUS_LIFE   2      /* 1 second minimum for rounding */
#define USE_M        0x0001 /* mtime                         */
#define USE_C        0x0002 /* ctime                         */
#define USE_B        0x0004 /* birthtime                     */
#define USE_L        0x0008 /* lock                          */
#define USE_A        0x0010 /* atime                         */
#define USE_P        0x0020 /* link point                    */
#define USE_O        0x0040 /* uid                           */
#define USE_G        0x0080 /* gid                           */
#define USE_R        0x0100 /* mode                          */
#define NO_RM        0x8000
#define NOW          (time(NULL))
#define C_PID_LEN    8
#define FREE_TREE(A) do {free_tree(A); A = NULL;} while(0)
#define ERROUT(A,B)  do {ex = (A); errno = (B); goto out;} while(0)
#define EXOUT(A)     do {ex = (A); goto out;} while(0)

typedef struct d_entry d_entry;
typedef struct deleted_pid deleted_pid;

typedef enum
{   undef = -1
,   false = 0
,   true  = 1
} bool;

typedef struct {
    time_t       ttl;
    uid_t        own;
    gid_t        grp;
    mode_t       mod;
    u_int16_t    mask;
} aim;

struct deleted_pid {
    char         cpid[C_PID_LEN];
    u_int64_t    id;
    u_int16_t    version;
    u_int16_t    dpss;
    BLIN_flag    flags;
#   define       DELETED_QUERY 0x000100
    const char  *pidname;
    deleted_pid *conf;
    time_t       wake_up;
    aim          fmask;
    aim          dmask;
    aim          lmask;
    pid_t        pid;
    int16_t      prio;
    bool         res_low;
};

struct d_entry {
    d_entry     *next;
    d_entry     *high;
    char        *name;
    time_t       time;
};

void     debug_date __P((FILE *f, time_t time));
int      query      __P((deleted_pid *parm));
d_entry *build_tree __P((deleted_pid *parm, const char *path));
void     free_tree  __P((d_entry *tree));
